/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <gtk/gtk.h>

#include "global_vars.h"
#include "dialog.h"

void gM_dialog_destroy(GtkWidget *w, GtkWidget *dialog);
int question_dialog_ret;
void question_dialog_CB(GtkWidget *w, int i);


void gM_dialog_show(char *title, char *text, char modal) {
  GtkWidget *dialog;
  GtkWidget *tmp;

  dialog = gtk_dialog_new ();
  gtk_window_set_title(GTK_WINDOW(dialog), title);
  gtk_window_set_policy(GTK_WINDOW(dialog), TRUE, TRUE, FALSE);
  gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_MOUSE);
  gtk_window_set_modal(GTK_WINDOW(dialog), modal);

  gtk_widget_show(GTK_DIALOG(dialog)->vbox);
  gtk_widget_show(GTK_DIALOG(dialog)->action_area);
  gtk_container_border_width(GTK_CONTAINER(GTK_DIALOG(dialog)->action_area), 10);

  tmp = gtk_label_new(text);
  gtk_misc_set_padding(GTK_MISC(tmp), 5, 5);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), tmp, TRUE, TRUE, 0);

  tmp = gtk_button_new_with_label(_("   OK   "));
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->action_area), tmp, TRUE, TRUE, 0);
  GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  gtk_widget_grab_focus (tmp);
  gtk_widget_grab_default (tmp);
  gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(gM_dialog_destroy), (void *) dialog);
  
  gtk_widget_show(dialog);
}

void gM_dialog_destroy(GtkWidget *w, GtkWidget *dialog) {

  gtk_widget_hide(dialog);
  gtk_widget_destroy(dialog);

}

int gM_dialog_show_question(char *title, char *text, int buttons) {
	GtkWidget *Window;
  GtkWidget *tmp;
	GtkWidget *vbox;
	GtkWidget *hbox;
  GtkWidget *con;

	question_dialog_ret = 0;

  Window = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_position(GTK_WINDOW(Window), GTK_WIN_POS_MOUSE); 
  gtk_window_set_title(GTK_WINDOW(Window),title);
  gtk_window_set_policy(GTK_WINDOW(Window), FALSE, FALSE, FALSE);
  gtk_window_set_modal(GTK_WINDOW(Window), TRUE);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(Window), vbox);

  con = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(con);
  gtk_box_pack_start(GTK_BOX(vbox), con, TRUE, TRUE, 0);
  gtk_container_border_width(GTK_CONTAINER(con), 10);

  tmp = gtk_label_new(text);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(con), tmp, TRUE, TRUE, 0);


  tmp = gtk_hseparator_new ();
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, FALSE, 0);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, FALSE, 0);
  gtk_container_border_width(GTK_CONTAINER(hbox), 10);

  if(buttons & bYes) {
    tmp = gtk_button_new_with_label(_(" Yes "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bYes);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  if(buttons & bAll) {
    tmp = gtk_button_new_with_label(_(" All "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bAll);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  if(buttons & bOK) {
    tmp = gtk_button_new_with_label(_(" OK "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bOK);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  if(buttons & bNo) {
    tmp = gtk_button_new_with_label(_(" No "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bNo);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  if(buttons & bCancel) {
    tmp = gtk_button_new_with_label(_(" Cancel "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bCancel);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  if(buttons & bRetry) {
    tmp = gtk_button_new_with_label(_(" Retry "));
    gtk_widget_show(tmp);
    gtk_box_pack_start(GTK_BOX(hbox), tmp, TRUE, TRUE, 5);
    gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(question_dialog_CB), (gpointer) bRetry);
    GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  }
  gtk_widget_grab_focus (tmp);
  gtk_widget_grab_default (tmp);

  gtk_widget_show(Window);

	while(question_dialog_ret == 0) {
		gtk_main_iteration_do(TRUE);
	}
  
  gtk_widget_hide(Window);
  gtk_widget_destroy(Window);
  
	return question_dialog_ret;
}

void question_dialog_CB(GtkWidget *w, int i) {
	question_dialog_ret = i;
}
