/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include <gdk/gdkkeysyms.h>

#include <stdio.h>
#include <stdlib.h>

#include "structs.h"
#include "dialog.h"
#include "worlds.h"
#include "dialogs.h"
#include "config.h"
#include "handy.h"
#include "help.h"
#include "syntaxhl.h"
#include "window.h"
#include "world.h"
#include "global_vars.h"

#define _OK     0
#define _CANCEL 1
#define _REMOVE 2
#define _HELP   3

#define NONE      0
#define SIMPLE    1
#define SELECTIVE 2

void butcallback(GtkWidget *w, int but);
void checkcallback(GtkWidget *w, void *pointer);
void destroy_cb_new(GtkWidget *w, void *pointer);
GtkWidget *dialog_new = NULL;
GtkWidget *entry1;
GtkWidget *entry2;
GtkWidget *entry3;
GtkWidget *entry5;
GtkWidget *entry4;
GtkWidget *check;


void butcallback2(GtkWidget *w, int but);
void destroy_cb_open(GtkWidget *w, void *pointer);
GtkWidget *dialog_open = NULL;
void add_to_list(GtkWidget *data, GtkWidget *list);
void set_current_item(GtkWidget *item, GdkEventButton *event, char *data);
void set_current_item2(GtkWidget *item, GdkEventKey *event, char *data);
char *current_item = NULL;
int parse_opt();
int pparse_opt();

void pbutcallback(GtkWidget *w, int but);
void pcheckcallback(GtkWidget *w, void *pointer);
void destroy_cb_pnew(GtkWidget *w, void *pointer);
void prop_switch_page(GtkWidget *nb, GtkWidget *nbp, int page_num, void *pointer);
GtkWidget *pdialog_new = NULL;
GtkWidget *pentry1;
GtkWidget *pentry2;
GtkWidget *pentry3;
GtkWidget *pentry5;
GtkWidget *pentry4;
GtkWidget *pcheck;
world *cur_pref = NULL;
int current_tab2;

void gM_dialogs_new_world() {
  GtkWidget *tmp;
  GtkWidget *vbox;
    GtkWidget *frame;
      GtkWidget *table;
    GtkWidget *frame2;
      GtkWidget *table2;
    GtkWidget *bbox;
      GtkWidget *butOk;
      GtkWidget *butCancel;
      GtkWidget *butHelp;

  if(dialog_new != NULL) /* ensure one open window, or global vars are fucking up */
    return;

  dialog_new = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(dialog_new), "Create a new world");
  gtk_window_position(GTK_WINDOW(dialog_new), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy(GTK_WINDOW(dialog_new), FALSE, FALSE, FALSE);
  gtk_signal_connect(GTK_OBJECT(dialog_new), "destroy", GTK_SIGNAL_FUNC(destroy_cb_new), NULL);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(dialog_new), vbox);
  
  /* begin topframe */
  frame = gtk_frame_new(_("World data: "));
  gtk_widget_show(frame);
  gtk_box_pack_start(GTK_BOX(vbox), frame, TRUE, TRUE, 0);
  gtk_container_border_width(GTK_CONTAINER(frame), 5);

  table = gtk_table_new(4, 2, FALSE);
  gtk_widget_show(table);
  gtk_container_add(GTK_CONTAINER(frame), table);

  /* labels top frame */
  tmp = gtk_label_new(_("Worldname:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  tmp = gtk_label_new(_("Hostname:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  tmp = gtk_label_new (_("Port:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  /* entrys top frame */
  entry1 = gtk_entry_new ();
  gtk_widget_show (entry1);
  gtk_table_attach (GTK_TABLE (table), entry1, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  entry2 = gtk_entry_new ();
  gtk_widget_show (entry2);
  gtk_table_attach (GTK_TABLE (table), entry2, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  entry3 = gtk_entry_new ();
  gtk_widget_show (entry3);
  gtk_table_attach (GTK_TABLE (table), entry3, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);


  /* begin bottom frame */
  frame2 = gtk_frame_new(_("Automatic login"));
  gtk_widget_show(frame2);
  gtk_table_attach(GTK_TABLE(table), frame2, 0, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_container_border_width(GTK_CONTAINER(frame2), 5);

  table2 = gtk_table_new(3, 2, FALSE);
  gtk_widget_show(table2);
  gtk_container_add(GTK_CONTAINER(frame2), table2);

  /* begin bottom frame checkbox */
  check = gtk_check_button_new_with_label(_("Enable automatic login"));
/*  gtk_button_clicked(GTK_BUTTON(check)); */
  gtk_widget_show(check);
  gtk_table_attach(GTK_TABLE(table2), check, 0, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_container_border_width(GTK_CONTAINER(check), 5);
  gtk_signal_connect(GTK_OBJECT(check), "clicked", GTK_SIGNAL_FUNC(checkcallback), NULL);

  /* begin bottom frame labels */
  tmp = gtk_label_new(_("Username:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table2), tmp, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);

  tmp = gtk_label_new(_("Password:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table2), tmp, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);

  /* begin bottom frame entrys */
  entry4 = gtk_entry_new ();
  gtk_widget_show (entry4);
  gtk_table_attach (GTK_TABLE (table2), entry4, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_widget_set_sensitive(entry4, FALSE);

  entry5 = gtk_entry_new ();
  gtk_widget_show (entry5);
  gtk_table_attach (GTK_TABLE (table2), entry5, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_entry_set_visibility(GTK_ENTRY(entry5), FALSE);
  gtk_widget_set_sensitive(entry5, FALSE);
  
  /* begin rests */
  tmp = gtk_hseparator_new();
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, TRUE, 5);

  bbox = gtk_hbutton_box_new ();
  gtk_widget_show (bbox);
  gtk_box_pack_start (GTK_BOX (vbox), bbox, FALSE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (bbox), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (bbox), 10);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox), 0, 0);

  butOk = gtk_button_new_with_label(_("OK"));
  gtk_widget_show(butOk);
  gtk_container_add(GTK_CONTAINER(bbox), butOk);
  gtk_signal_connect(GTK_OBJECT(butOk), "clicked", GTK_SIGNAL_FUNC(butcallback), (void *) _OK);
  GTK_WIDGET_SET_FLAGS (butOk, GTK_CAN_DEFAULT);

  butCancel = gtk_button_new_with_label(_("Cancel"));
  gtk_widget_show(butCancel);
  gtk_container_add(GTK_CONTAINER(bbox), butCancel);
  gtk_signal_connect(GTK_OBJECT(butCancel), "clicked", GTK_SIGNAL_FUNC(butcallback), (void *) _CANCEL);
  GTK_WIDGET_SET_FLAGS (butCancel, GTK_CAN_DEFAULT);

  butHelp = gtk_button_new_with_label(_("Help"));
  gtk_widget_show(butHelp);
  gtk_container_add(GTK_CONTAINER(bbox), butHelp);
  gtk_signal_connect(GTK_OBJECT(butHelp), "clicked", GTK_SIGNAL_FUNC(butcallback), (void *) _HELP);
  GTK_WIDGET_SET_FLAGS (butHelp, GTK_CAN_DEFAULT);
  gtk_widget_grab_focus (butHelp);
  gtk_widget_grab_default (butHelp);

  gtk_widget_show(dialog_new);
}

void destroy_cb_new(GtkWidget *w, void *pointer) {
  dialog_new = NULL;
}

void butcallback(GtkWidget *w, int but) {
  switch(but) {
  case _OK:
    if(parse_opt() < 0)
      return;
    gtk_widget_hide(dialog_new);
    gtk_widget_destroy(dialog_new);
    break;
  case _CANCEL:
    gtk_widget_hide(dialog_new);
    gtk_widget_destroy(dialog_new);
    break;
  case _HELP:
    gM_help_show_new_and_properties();
  }
}


void checkcallback(GtkWidget *w, void *pointer) {
  gtk_widget_set_sensitive(entry4, GTK_TOGGLE_BUTTON(w)->active);
  gtk_widget_set_sensitive(entry5, GTK_TOGGLE_BUTTON(w)->active);
}

int parse_opt() {
  char *s;
  gM_newworld nw;
  
  s = gtk_entry_get_text(GTK_ENTRY(entry1));
  if(strlen(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Worldname field has a invalid value  "), 1);
    return -1;
  } else if(s[0] == '.') {
    gM_dialog_show(_("Error:"),_("The Worldname field has a invalid value,  \n"
                            "Please don't start the name of the world  \nwith a '.'  "), 1);
    return -1;
  } else
    nw.name = s;
    
  s = gtk_entry_get_text(GTK_ENTRY(entry2));
  if(strlen(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Hostname field has a invalid value  "), 1);
    return -1;
  } else
    nw.host = s;
  
  s = gtk_entry_get_text(GTK_ENTRY(entry3));
  if(strlen(s) < 1 || atoi(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Port field has a invalid value  \n(must be a number)  "), 1);
    return -1;
  } else
   nw.port = atoi(s);
  
 
  nw.autoconnect = GTK_TOGGLE_BUTTON(check)->active;
  s = gtk_entry_get_text(GTK_ENTRY(entry4));
  if(strlen(s) < 1) {
    if(nw.autoconnect > 0) {
      gM_dialog_show(_("Error:"),_("The Username field has a invalid value  "), 1);
      return -1;
    } else
      nw.user = EMPTY_STR;
  } else
    nw.user = s;
  
  s = gtk_entry_get_text(GTK_ENTRY(entry5));
  if(strlen(s) < 1) {
    if(nw.autoconnect > 0) {
      gM_dialog_show(_("Error:"),_("The Password field has a invalid value  "), 1);
      return -1;
    } else
      nw.pass = EMPTY_STR;
  } else
    nw.pass = s;
  
  gM_config_create_new_world(&nw);
  gM_worlds_add_world(nw.name);
  return 1; /* parsing complete */
}

/****************************************************************************
 *
 *  Dialog Open
 *
 ****************************************************************************/

void gM_dialogs_open_world() {
  GtkWidget *hbox;
  GtkWidget *frame;
  GtkWidget *list;
  GtkWidget *vbox;
  GtkWidget *tmp;
  GList *listdata;
  GList *ltmp;
  GtkWidget *scrollw;

  if(dialog_open != NULL) /* ensure one open window, or global vars are fucking up */
    return;

  dialog_open = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(dialog_open), _("Open World"));
  gtk_window_position(GTK_WINDOW(dialog_open), GTK_WIN_POS_MOUSE);
  gtk_window_set_default_size(GTK_WINDOW(dialog_open), 0, 200);
  gtk_signal_connect(GTK_OBJECT(dialog_open), "destroy", GTK_SIGNAL_FUNC(destroy_cb_open), NULL);

  hbox = gtk_hbox_new(FALSE, 0);
  gtk_widget_show(hbox);
  gtk_container_add(GTK_CONTAINER(dialog_open), hbox);

  frame = gtk_frame_new(_("List of created Worlds: "));
  gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
  gtk_widget_show(frame);
  gtk_box_pack_start(GTK_BOX(hbox), frame, TRUE, TRUE, 0);

  scrollw = gtk_scrolled_window_new(NULL, NULL);
  gtk_widget_show(scrollw);
  gtk_container_add(GTK_CONTAINER(frame), scrollw);
  gtk_scrolled_window_set_policy(	GTK_SCROLLED_WINDOW(scrollw), GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
  
  list = gtk_list_new ();
  gtk_container_set_border_width(GTK_CONTAINER(list), 5);
  gtk_list_set_selection_mode(GTK_LIST(list), GTK_SELECTION_BROWSE);
  gtk_widget_show(list);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrollw), list);

  listdata = gM_config_get_world_names();
  g_list_foreach(listdata, (GFunc) add_to_list, (void *) list);
  for(ltmp = listdata; ltmp != NULL && ltmp->data == NULL; ltmp = ltmp->next);
  gtk_window_set_focus(GTK_WINDOW(dialog_open), GTK_WIDGET(ltmp->data));
  g_list_free(listdata);

  vbox = gtk_vbox_new(FALSE, 10);
  gtk_widget_show(vbox);
  gtk_box_pack_end(GTK_BOX(hbox), vbox, FALSE, FALSE, 0);
  gtk_container_border_width(GTK_CONTAINER (vbox), 10);

  tmp = gtk_button_new_with_label(_("Open"));
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(butcallback2), (void *) _OK);
  GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);

  tmp = gtk_button_new_with_label(_("Cancel"));
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(butcallback2), (void *) _CANCEL);
  GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);

  tmp = gtk_button_new_with_label(_("Remove"));
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, TRUE, 20);
  gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(butcallback2), (void *) _REMOVE);
  GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);

  tmp = gtk_button_new_with_label(_("Help"));
  gtk_widget_show(tmp);
  gtk_box_pack_end(GTK_BOX(vbox), tmp, FALSE, TRUE, 0);
  gtk_signal_connect(GTK_OBJECT(tmp), "clicked", GTK_SIGNAL_FUNC(butcallback2), (void *) _HELP);
  GTK_WIDGET_SET_FLAGS (tmp, GTK_CAN_DEFAULT);
  gtk_widget_grab_default (tmp);

  gtk_widget_grab_focus (list);

  gtk_widget_show(dialog_open);
}

void destroy_cb_open(GtkWidget *w, void *pointer) {
  dialog_open = NULL;
  current_item = NULL;
}

void butcallback2(GtkWidget *w, int but) {
  switch(but) {
  case _OK:
    gtk_widget_hide(dialog_open);
    gM_worlds_add_world(current_item);
  case _CANCEL:
    gtk_widget_destroy(dialog_open);
    break;
  case _REMOVE:
    if(gM_dialog_show_question(_("Conformation:"), _("Are you REALLY sure you wish to delete that world ?"),
    bYes | bNo)
       != bYes)
      return;
    if(gM_config_remove_world_file(current_item) > 0) {
    	gtk_widget_hide(dialog_open);
      gtk_widget_destroy(dialog_open);
      gM_dialogs_open_world();
    } else
      gM_dialog_show(_("Error:"), _("There was an error removing the world  "), 1);
    break;
  case _HELP:
    gM_help_show_open();
  }
}

void add_to_list(GtkWidget *data, GtkWidget *list) {
  if(data != NULL) {
    gtk_container_add(GTK_CONTAINER(list), data);

    gtk_signal_connect(GTK_OBJECT(data), "button_press_event",
                       GTK_SIGNAL_FUNC(set_current_item), GTK_LABEL(GTK_BIN(data)->child)->label);
    gtk_signal_connect(GTK_OBJECT(data), "key_press_event",
                       GTK_SIGNAL_FUNC(set_current_item2), GTK_LABEL(GTK_BIN(data)->child)->label);

    if(current_item == NULL)
      current_item = GTK_LABEL(GTK_BIN(data)->child)->label;
  }
}

void set_current_item(GtkWidget *item, GdkEventButton *event, char *data) {
  current_item = data;
  if(event->type == GDK_2BUTTON_PRESS) {
    butcallback2(NULL, _OK);
  }
}

void set_current_item2(GtkWidget *item, GdkEventKey *event, char *data) {
  current_item = data;
  if(event->keyval == GDK_Return || event->keyval == GDK_KP_Enter) {
    butcallback2(NULL, _OK);
  }
}

/************************************************************************
 *
 *  Dialog Properties
 *
 ***********************************************************************/

void gM_dialogs_world_properties(world *w) {
  GtkWidget *nb;

  GtkWidget *tmp;
  GtkWidget *vbox;
    GtkWidget *table;
      GtkWidget *frame2;
        GtkWidget *table2;
    GtkWidget *bbox;
      GtkWidget *butOk;
      GtkWidget *butCancel;
      GtkWidget *butHelp;
  char s[20]; /* must B long enought */

  if(pdialog_new != NULL) /* ensure one open window, or global vars are fucking up */
    return;
  cur_pref = w;

  pdialog_new = gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(pdialog_new), _("Properties"));
  gtk_window_position(GTK_WINDOW(pdialog_new), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy(GTK_WINDOW(pdialog_new), FALSE, FALSE, FALSE);
  gtk_signal_connect(GTK_OBJECT(pdialog_new), "destroy", GTK_SIGNAL_FUNC(destroy_cb_pnew), NULL);

  vbox = gtk_vbox_new(FALSE, 0);
  gtk_widget_show(vbox);
  gtk_container_add(GTK_CONTAINER(pdialog_new), vbox);

  nb = gtk_notebook_new();
  gtk_widget_show(nb);
  gtk_container_border_width(GTK_CONTAINER(nb), 5);
  gtk_notebook_set_scrollable(GTK_NOTEBOOK(nb), TRUE);
  gtk_box_pack_start(GTK_BOX(vbox), nb, TRUE, TRUE, 0);
  gtk_signal_connect_after(GTK_OBJECT(nb), "switch_page", GTK_SIGNAL_FUNC(prop_switch_page), NULL);

  
  table = gtk_table_new(4, 2, FALSE);
  gtk_widget_show(table);
  gtk_container_border_width(GTK_CONTAINER(table), 5);

  /* labels top frame */
  tmp = gtk_label_new(_("Worldname:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  tmp = gtk_label_new(_("Hostname:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_label_set_justify(GTK_LABEL(tmp), GTK_JUSTIFY_LEFT);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  tmp = gtk_label_new (_("Port:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table), tmp, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_misc_set_alignment(GTK_MISC(tmp), 0.1, 0.5);

  /* entrys top frame */
  pentry1 = gtk_entry_new ();
  gtk_widget_show(pentry1);
  gtk_table_attach(GTK_TABLE (table), pentry1, 1, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  pentry2 = gtk_entry_new ();
  gtk_widget_show (pentry2);
  gtk_table_attach (GTK_TABLE (table), pentry2, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);

  pentry3 = gtk_entry_new ();
  gtk_widget_show (pentry3);
  gtk_table_attach (GTK_TABLE (table), pentry3, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);


  /* begin bottom frame */
  frame2 = gtk_frame_new(_("Automatic login"));
  gtk_widget_show(frame2);
  gtk_table_attach(GTK_TABLE(table), frame2, 0, 2, 3, 4,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_EXPAND | GTK_FILL, 0, 0);
  gtk_container_border_width(GTK_CONTAINER(frame2), 5);

  table2 = gtk_table_new(3, 2, FALSE);
  gtk_widget_show(table2);
  gtk_container_add(GTK_CONTAINER(frame2), table2);
  gtk_container_border_width(GTK_CONTAINER(table2), 5);

  /* begin bottom frame checkbox */
  pcheck = gtk_check_button_new_with_label(_("Enable automatic login"));
  gtk_widget_show(pcheck);
  gtk_table_attach(GTK_TABLE(table2), pcheck, 0, 2, 0, 1,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);
  gtk_container_border_width(GTK_CONTAINER(pcheck), 5);
  gtk_signal_connect(GTK_OBJECT(pcheck), "clicked", GTK_SIGNAL_FUNC(pcheckcallback), NULL);

  /* begin bottom frame labels */
  tmp = gtk_label_new(_("Username:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table2), tmp, 0, 1, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);

  tmp = gtk_label_new(_("Password:"));
  gtk_widget_show(tmp);
  gtk_table_attach(GTK_TABLE(table2), tmp, 0, 1, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) 0, 0, 0);

  /* begin bottom frame entrys */
  pentry4 = gtk_entry_new ();
  gtk_widget_show (pentry4);
  gtk_table_attach (GTK_TABLE (table2), pentry4, 1, 2, 1, 2,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_widget_set_sensitive(pentry4, FALSE);

  pentry5 = gtk_entry_new ();
  gtk_widget_show (pentry5);
  gtk_table_attach (GTK_TABLE (table2), pentry5, 1, 2, 2, 3,
                    (GtkAttachOptions) GTK_EXPAND | GTK_FILL, (GtkAttachOptions) GTK_FILL, 0, 0);
  gtk_entry_set_visibility(GTK_ENTRY(pentry5), FALSE);
  gtk_widget_set_sensitive(pentry5, FALSE);
  
  /* begin rests */
  tmp = gtk_hseparator_new();
  gtk_widget_show(tmp);
  gtk_box_pack_start(GTK_BOX(vbox), tmp, FALSE, TRUE, 5);

  bbox = gtk_hbutton_box_new ();
  gtk_widget_show (bbox);
  gtk_box_pack_start (GTK_BOX (vbox), bbox, FALSE, TRUE, 0);
  gtk_container_border_width (GTK_CONTAINER (bbox), 5);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (bbox), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (bbox), 10);
  gtk_button_box_set_child_size (GTK_BUTTON_BOX (bbox), 0, 0);

  butOk = gtk_button_new_with_label(_("OK"));
  gtk_widget_show(butOk);
  gtk_container_add(GTK_CONTAINER(bbox), butOk);
  gtk_signal_connect(GTK_OBJECT(butOk), "clicked", GTK_SIGNAL_FUNC(pbutcallback), (void *) _OK);
  GTK_WIDGET_SET_FLAGS (butOk, GTK_CAN_DEFAULT);

  butCancel = gtk_button_new_with_label(_("Cancel"));
  gtk_widget_show(butCancel);
  gtk_container_add(GTK_CONTAINER(bbox), butCancel);
  gtk_signal_connect(GTK_OBJECT(butCancel), "clicked", GTK_SIGNAL_FUNC(pbutcallback), (void *) _CANCEL);
  GTK_WIDGET_SET_FLAGS (butCancel, GTK_CAN_DEFAULT);

  butHelp = gtk_button_new_with_label(_("Help"));
  gtk_widget_show(butHelp);
  gtk_container_add(GTK_CONTAINER(bbox), butHelp);
  gtk_signal_connect(GTK_OBJECT(butHelp), "clicked", GTK_SIGNAL_FUNC(pbutcallback), (void *) _HELP);
  GTK_WIDGET_SET_FLAGS (butHelp, GTK_CAN_DEFAULT);
  gtk_widget_grab_focus (butHelp);
  gtk_widget_grab_default (butHelp);

  gtk_entry_set_text(GTK_ENTRY(pentry1), w->name);
  gtk_widget_set_sensitive(pentry1, FALSE);
  gtk_entry_set_text(GTK_ENTRY(pentry2), w->host);
  sprintf(s, "%d", w->port);
  gtk_entry_set_text(GTK_ENTRY(pentry3), s);

  gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(pcheck), w->autoconnect);
  if(w->user != NULL)
    gtk_entry_set_text(GTK_ENTRY(pentry4), w->user);
  if(w->password != NULL)
    gtk_entry_set_text(GTK_ENTRY(pentry5), w->password);

  tmp = gtk_label_new(_("World data"));
  gtk_widget_show(tmp);
  gtk_notebook_append_page(GTK_NOTEBOOK(nb), table, tmp);

  gtk_widget_show(pdialog_new);
}

void prop_switch_page(GtkWidget *nb, GtkWidget *nbp, int page_num, void *pointer) {
  current_tab2 = page_num;
}

void destroy_cb_pnew(GtkWidget *w, void *pointer) {
  pdialog_new = NULL;
  cur_pref = NULL;
}


void pbutcallback(GtkWidget *w, int but) {
  switch(but) {
  case _OK:
    if(pparse_opt() < 0)
      return;
  case _CANCEL:
    gtk_widget_hide(pdialog_new);
    gtk_widget_destroy(pdialog_new);
    break;
  case _HELP:
    if(current_tab2 == 0)
      gM_help_show_new_and_properties();
    /* else if more tabs ... */
  }
}


void pcheckcallback(GtkWidget *w, void *pointer) {
  gtk_widget_set_sensitive(pentry4, GTK_TOGGLE_BUTTON(w)->active);
  gtk_widget_set_sensitive(pentry5, GTK_TOGGLE_BUTTON(w)->active);
}

int pparse_opt() {
  char *s;
  gM_newworld nw;
  
  s = gtk_entry_get_text(GTK_ENTRY(pentry1));
  if(strlen(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Worldname field has a invalid value  "), 1);
    return -1;
  } else if(s[0] == '.') {
    gM_dialog_show(_("Error:"),_("The Worldname field has a invalid value,  \n"
                   "Please don't start the name of the world \nwith a '.'  "), 1);
    return -1;
  } else
    nw.name = s;
    
  s = gtk_entry_get_text(GTK_ENTRY(pentry2));
  if(strlen(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Hostname field has a invalid value  "), 1);
    return -1;
  } else
    nw.host = s;
  
  s = gtk_entry_get_text(GTK_ENTRY(pentry3));
  if(strlen(s) < 1 || atoi(s) < 1) {
    gM_dialog_show(_("Error:"),_("The Port field has a invalid value  \n(must be a number)  "), 1);
    return -1;
  } else
   nw.port = atoi(s);
  
 
  nw.autoconnect = GTK_TOGGLE_BUTTON(pcheck)->active;
  s = gtk_entry_get_text(GTK_ENTRY(pentry4));
  if(strlen(s) < 1) {
    if(nw.autoconnect > 0) {
      gM_dialog_show(_("Error:"),_("The Username field has a invalid value  "), 1);
      return -1;
    } else
      nw.user = EMPTY_STR;
  } else
    nw.user = s;
  
  s = gtk_entry_get_text(GTK_ENTRY(pentry5));
  if(strlen(s) < 1) {
    if(nw.autoconnect > 0) {
      gM_dialog_show(_("Error:"),_("The Password field has a invalid value  "), 1);
      return -1;
    } else
      nw.pass = EMPTY_STR;
  } else
    nw.pass = s;

  gM_config_recreate_world(&nw);

  g_free(cur_pref->host);
  cur_pref->host = strnew(nw.host);

  cur_pref->port = nw.port;

  if(cur_pref->user != NULL)
    g_free(cur_pref->user);
  cur_pref->user = strcmp(nw.user, EMPTY_STR) == 0 ? NULL : strnew(nw.user);

  if(cur_pref->password != NULL)
    g_free(cur_pref->password);
  cur_pref->password = strcmp(nw.pass, EMPTY_STR) == 0 ? NULL : strnew(nw.pass);

  cur_pref->autoconnect = nw.autoconnect;

#if 0 /* macros */
  gM_macros_save(cur_pref);
#endif
    
  return 1; /* parsing complete */
}

