/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef gM_handy_h
#define gM_handy_h

#define strnew(str) strcpy(g_malloc(strlen(str) + 1), str)
#define strcatnew(s1, s2) strcat(strcpy(g_malloc(strlen(s1) + strlen(s2) + 1), s1), s2)
#define strcat3new(s1, s2, s3) strcat(strcat(strcpy(g_malloc(strlen(s1) + strlen(s2) + strlen(s3) + 3), s1), s2), s3)

char *strrcasechr(char *s, char c);
/* replaces all the chars replace by the char by */
void  strsub(char *s, char replace, char by);


int parse_yes_or_no(char *what);
/* retrun a malloc()ed string, lowercased */
char *strtolower(char *string, int len);

char *get_time();
char *get_date();

#define FOR_WORLD 1
#define FOR_EDITOR 2
void limit_to_20(int for_what, char *from, char **to);

char *strconcatnew(int argc, ...);

void strappend(char **s, char c);
int strendswith(char *s, char *s2, int cases);
char *strcasestr(char *haystack, char *needle);

char *skip_esc_code(char *s);

char *strip_chars(char *s, int len, int *j);

char *get_1st_from(char *s);
char *format_for_tcl(char *command, char *ID, char *line);

char *quote_for_tcl(char *line);

#endif
