/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
#include<stdio.h>
#include<string.h>
#include<stdlib.h>
#include"syntaxhl.h"

#define HL_VARCHAR(x) (((x>='A')&&(x<='Z'))||((x>='a')&&(x<='z'))||(x=='_'))
#define HL_NUMCHAR(x) ((x>='0')&&(x<='9'))
#define HL_KEYWORD(x) \
((strcasecmp("for",x)==0) ||      \
 (strcasecmp("endfor",x)==0) ||   \
 (strcasecmp("while",x)==0) ||    \
 (strcasecmp("endwhile",x)==0) || \
 (strcasecmp("if",x)==0) ||       \
 (strcasecmp("elseif",x)==0) ||   \
 (strcasecmp("else",x)==0) ||     \
 (strcasecmp("endif",x)==0) ||    \
 (strcasecmp("try",x)==0) ||      \
 (strcasecmp("except",x)==0) ||   \
 (strcasecmp("endtry",x)==0) ||   \
 (strcasecmp("fork",x)==0) ||     \
 (strcasecmp("endfork",x)==0) ||  \
 (strcasecmp("in",x)==0))
#define HL_COLOR(x) if(color!=x) add(dest,color=x);


void parse(char *dest,char *src);

void add(char *s,char c){
	int len;
	len=strlen(s);
	s[len]=c;s[len+1]=0;
}

char *shl(char *dest,char *src){
	int i,j,comment;
	char *tempstr,color = 0; /* Added  =0 on the color def, removed a
                            * `might be used uninitialized' warning
                            * with it */

	tempstr=(char *)malloc(strlen(src)+1);

	dest[0]=0;

	for(i=0;src[i]!=0;i++){

/*** STRING OR COMMENT ***/
		if(src[i]=='"'){
			comment=1;
			for(j=i-1;(j>=0)&&(src[j]!=10);j--)
				if(src[j]!=' '){
					comment=0;
					break;
				}
			tempstr[0]=0;
			add(tempstr,'"');
			i++;
			j=0;
			while(!((src[i]=='"')&&(j%2==0))&&(src[i]!=0)&&(src[i]!=10)){
				j=(src[i]=='\\'?j+1:0);
				add(tempstr,src[i++]);
			}
			if(src[i]=='"') {add(tempstr,'"');i++;}
			for(j=i;(src[j]!=0)&&(src[j]!=10)&&(src[j]!=';');j++)
				if(src[j]!=' '){
					comment=0;
					break;
				}
			HL_COLOR(comment?HL_COMMEN:HL_STRING);
			strcat(dest,tempstr);
			if(src[i]==0) break;
			if(comment) add(dest,src[i]);
			else i--;
		}

/*** NUMBER ***/
		else if(HL_NUMCHAR(src[i])){
			HL_COLOR(HL_NUMBER);
			while(HL_NUMCHAR(src[i])||((src[i]=='.')&&(HL_NUMCHAR(src[i+1])))){
				add(dest,src[i]);
				i++;
			}
			i--;
		}

/*** VARIABLE OR KEYWORD ***/
		else if(HL_VARCHAR(src[i])){
			tempstr[0]=0;
			while(HL_VARCHAR(src[i])||HL_NUMCHAR(src[i])){
				add(tempstr,src[i]);
				i++;
			}
			i--;
			if(HL_KEYWORD(tempstr)){
				HL_COLOR(HL_KEYWRD);
			}else HL_COLOR(HL_VARIAB);
			strcat(dest,tempstr);
		}

/*** OBJECTNUMBER ***/
		else if(src[i]=='#'){
			HL_COLOR(HL_OBJNUM);
			add(dest,'#');
			i++;
			while(HL_NUMCHAR(src[i])){
				add(dest,src[i]);
				i++;
			}
			i--;
		}

/*** DOLLAR ***/
		else if(src[i]=='$'){
			if(HL_VARCHAR(src[i+1])){
				HL_COLOR(HL_DOLLAR);
				add(dest,'$');
				i++;
				while(HL_VARCHAR(src[i])){
					add(dest,src[i]);
					i++;
				}
				i--;
			}else{
				HL_COLOR(HL_SYMBOL);
				add(dest,'$');
			}
		}

/*** OTHER SYMBOL ***/
		else{
			if(src[i]>' ') HL_COLOR(HL_SYMBOL);
			add(dest,src[i]);
		}
	}
  free(tempstr);
	return(dest);
}

/* used for standalone testing */
#if o
void parse(char *dest,char *src){
	int i;
	dest[0]=0;
	for(i=0;src[i]!=0;i++){
		switch(src[i]){
			case HL_STRING:strcat(dest,"\x1b[31m");break;
			case HL_NUMBER:strcat(dest,"\x1b[36m");break;
			case HL_OBJNUM:strcat(dest,"\x1b[34m");break;
			case HL_DOLLAR:strcat(dest,"\x1b[35m");break;
			case HL_VARIAB:strcat(dest,"\x1b[37m");break;
			case HL_KEYWRD:strcat(dest,"\x1b[32m");break;
			case HL_SYMBOL:strcat(dest,"\x1b[33m");break;
			case HL_COMMEN:strcat(dest,"\x1b[1;31m");break;
			default: add(dest,src[i]);
		}
	}
}

void main(){
	char src[2000],dest[20600];
	strcpy(src,"\"Commentaar....\"   ;\nif(args[1] in {$thing,\"$thing\",#3})\n  \"Dan dit:\";\n  for x in [1..10]\n    player:tell(\"ding\");\n  endfor\nendif\n\"blaat\";\n");
	shl(dest,src);
	parse(src,dest);
	printf("\n\n%s\x1b[0m",src);
/*	getch(); */
}
#endif

