/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef gM_world_h
#define gM_world_h




world *gM_world_new(char *worldname);

void gM_world_close(world *w);

void gM_world_show(world *w);
void gM_world_connect(world *w);
void gM_world_disconnect(world *w, int recon);

void gM_world_handle_output(world *w, char *s, int len);
void gM_world_handle_output_line(world *w, char *line, int len);

void gM_world_read(world *w, int source, GdkInputCondition con);
void gM_world_write(world *w, char *s);
void gM_world_write_hidden(world *w, char *s);

void gM_world_print(world *w, char *line, int len);
void gM_world_print_raw(world *w, char *line, int len);
void gM_world_clear_screen(world *w);
void gM_world_clear_buffer(world *w);

void set_global_color(GtkWidget *w);

void gM_world_force_update_linelen(world *w);

void gM_world_send_selection(world *w);

#endif

