/*  gMOO
 *  Copyright (C) 1999  Gert Scholten
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef gM_worlds_h
#define gM_worlds_h

#include "global_vars.h"

world *firstworld;
int clock_timeout;

void gM_worlds_init();
int  gM_worlds_close_all();

void gM_worlds_add_world(char *worldname);
int  gM_worlds_remove_world(world *w);

world *gM_worlds_get_by_main(GtkWidget *main);
world *gM_worlds_get_world_by_editor_main(GtkWidget *main, int *num);
#ifdef TCL
world *gM_worlds_get_by_interp(Tcl_Interp *interp);
world *gM_worlds_get_by_tcl_id(char *id);
#endif

void gM_worlds_reorder_pages();

void gM_worlds_update_clock();
void gM_worlds_update_default_color();
void gM_worlds_set_wordwrap(int on);

void gM_worlds_set_input_color();
void gM_worlds_show_sep();

void gM_worlds_set_tab_size();

int  clockfunc(void *pointer);

#endif
